/*
 * app.cpp
 * LED blink and UART test.
 * Written by audin. 2015/11 
 */
#include "mbed-drivers/mbed.h"

static Serial pc( USBTX, USBRX );
static InterruptIn button( BUTTON1 );
//InterruptIn button( SW2 );    /* For FRDM-K64F ? */

static int delay = 500;

/* Event for blinking LED */
void blinky() {
    static DigitalOut led1( LED1 );

    led1 = !led1;
    minar::Scheduler::postCallback( blinky )
        .delay( minar::milliseconds( delay ) );
}

/* Event for display */
void dispEvent(){
    static int num = 0;

    pc.printf("\n %05d: Delay = %d msec: SystemCoreClock = %u Hz" 
            ,num++,delay,(unsigned int)SystemCoreClock);
}

/* Event setting delay time */
void btn1Event(){
    static int id = 0;
    int dDelay[ 3 ]={500, 200, 100};

    id++;
    if( id > 2){
        id = 0;
    }
    delay = dDelay[ id ];
}

/* Interrupt by pushing button */
void btn1Intr(){
    /* Throw buttn evet function */
    minar::Scheduler::postCallback( btn1Event );
}

/* Program start point */
void app_start( int, char** ) {
    pc.baud( 115200 );
    button.rise( &btn1Intr );
    minar::Scheduler::postCallback( blinky );
    minar::Scheduler::postCallback( dispEvent ).period( minar::milliseconds( 500 ) );
}
